;   AT89C4051    (AT89C1051, AT89C2051  AT89C51, AT89C4052)    (MCS-51)
;    12 ,     1 
;   18B20   1820 -      !!! (   )
;   2       DS1307 (       )
;16,01,07  , . 
;  ()   ProView32  v3.3.4
;
REG_FLAG 		EQU 	2BH;   
;
;       1-WIRE
I_WIRE 					EQU 		P1.7;      
IO_BYTE 				EQU 		29H;   / /  1-
CRC						EQU 		2AH;     
;
;          
TEMPERATURA_L  	EQU 20H; - BYTE 0 -   
TEMPERATURA_H  	EQU 21H; - BYTE 1 -   
CRC_DATCHIKA    		EQU 28H; - BYTE 8 - CRC
TEMP_C								EQU	 40H; -   - 
;
 ;			I2C
SCL										EQU		P3.5;    
SDA										EQU		P3.4;
BUS_FAULT					EQU		REG_FLAG.0;   2
_2W_BUSY					EQU		REG_FLAG.1;  (   )
ACK                            EQU		REG_FLAG.2;   Ȩ
LASTREAD						EQU		REG_FLAG.3;    
DS1307W 						EQU 	0D0H;     1307
DS1307R 						EQU 	0D1H;       1307
BITCOUNT						EQU 	37H;    (  8)
;
;		  
SEC 									EQU 30H; 
MIN 										EQU 31H; 
CHA 									EQU 32H; 
;
;  
TEMP_BYTE_1			 					EQU 2CH;    
DELAY_BYTE_1 							EQU 2DH;    
DELAY_BYTE_2 							EQU 2EH;    
PERIOD_SMEN_POKAZ 		EQU 2FH;     
K_DELEN_PRER 						EQU 38H;      
;
; 
CRT_OK				BIT 		REG_FLAG.4;       
FLAG 						BIT 		REG_FLAG.5;      
MINUS 					BIT		 REG_FLAG.6;    
SOTNIA            BIT 		REG_FLAG.7;      99
;
;		 
DISPLEY_L 					EQU 35H;    
DISPLEY_H 					EQU 36H;    
;
; 
PERIOD_SMENI 			EQU 08H;    ()           
POPITOK_CHTENIA	EQU 0AH;   
;
;))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
;
ORG 00;
JMP BEGIN;
;
ORG 0BH;
JMP PRER;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;              
BEGIN:
            CLR RS0;
             CLR RS1;   0 

;               00h  3Fh 
            MOV R0,#00H;
U1:      	MOV @R0,#00H;
            INC R0;
            MOV A,R0;
            XRL A,#40H;
            JNZ U1;
;
            MOV K_DELEN_PRER, #64H;   
            MOV PERIOD_SMEN_POKAZ, #PERIOD_SMENI;      
            CLR FLAG;
            CLR SOTNIA;
            CLR MINUS;
            CLR CRT_OK;            
					MOV P3,#0FFH;      (   SDT  SCK  1307  )
					MOV SP,#60H ;  .    60
					
;  -
				MOV TMOD,#01H;    
;   					               . 
;      					           16  /
				SETB IE.7;     
				SETB IE.1;      
				SETB TCON.4;     
;			
CALL GET_TIME_1307;								   DS1307 
CALL SET_1307;												   1307,       .
CALL GET_T;       

;
START: 	
					CALL 	INDIC;
					CALL KLV;
					JMP START;
;					
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;      
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
PRER:
			MOV TH0,#0D8H;
			ORL TL0,#0F0H;
			PUSH ACC;   
			PUSH PSW;
				;    10 
			DJNZ K_DELEN_PRER, VOZVR;
				;  100 
				;    100    Vozvr
				;    : 
;				
;            				
				JB P1.7,N_E;    
            CLR FLAG;  
            JMP VOZVR;
N_E:	JB P3.7,N_R;    
            CLR FLAG;
            JMP VOZVR;
;				
N_R:	MOV K_DELEN_PRER,#64H;
				;  100    
				;    (  
				;     )	
			CALL GET_TIME_1307;								   DS1307  
			;			
			DJNZ PERIOD_SMEN_POKAZ, VOZVR;   X    .
			MOV PERIOD_SMEN_POKAZ, #PERIOD_SMENI;    /
;        
         CPL FLAG;       ,    / 
;         
			CALL GET_T;       
;         
;    - 
VOZVR:   
POP PSW;
POP ACC;   
RETI;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
INDIC:
      JB FLAG,INDIC_TERM;
      JMP INDIC_TIME;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;    
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
INDIC_TIME:
				MOV DISPLEY_L, MIN; 
				MOV DISPLEY_H,CHA; 
;
NACH:	MOV A,DISPLEY_L;
				CALL DECOD;
				MOV P1,A;
				CLR P3.0;
				CALL IND_DELAY;
				SETB P3.0;
;
				MOV A,DISPLEY_L;
				SWAP A;
				CALL DECOD;
				MOV P1,A;
				CLR P3.1;
				CALL IND_DELAY;
				SETB P3.1;
;
				MOV A,DISPLEY_H;
				CALL DECOD;
				MOV P1,A;	
				CLR P3.2;
				CALL IND_DELAY;
				SETB P3.2;
 ;
				MOV A,DISPLEY_H;
				SWAP A;
				ANL A,#0FH;
				JZ Z2;              
				CALL DECOD;       
				MOV P1,A;
				CLR P3.3;
				CALL IND_DELAY;
				SETB P3.3;
 Z2: 		 RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;    
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
INDIC_TERM:
		MOV DISPLEY_L,  TEMP_C;   
		
;   
      JB MINUS, MINU;      
		JB SOTNIA, STO;      
		MOV P1,#0FFH;        
		SETB P3.3;              
		JMP RAZ2;        	    
		
STO:  MOV P1,#0F9h;   -    
				CLR P3.3;
				CALL IND_DELAY;
				SETB P3.3;
 		JMP RAZ2;     
 		
MINU:   MOV P1,#0BFh;   -     
				CLR P3.3;
				CALL IND_DELAY;
				SETB P3.3;
;
RAZ2: MOV A,DISPLEY_L;   
		SWAP A;									
		ANL A,#0FH;                        
		JB SOTNIA, RR2;				      
		JNZ RR2;									        
		MOV P1, #0FFH;					   
		SETB P3.2;
		JMP RAZ1;								   
RR2:	CALL DECOD;          
		MOV P1,A;
				CLR P3.2;
				CALL IND_DELAY;
				SETB P3.2;
;
RAZ1:	MOV A,DISPLEY_L;      
		CALL DECOD;
		MOV P1,A;
				CLR P3.1;
				CALL IND_DELAY;
				SETB P3.1;
;
RAZ0: MOV P1,#9CH;  
				CLR P3.0;
				CALL IND_DELAY;
				SETB P3.0;
RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;      
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IND_DELAY:
		MOV DELAY_BYTE_1,#0FFH;
D:  NOP;
		DJNZ DELAY_BYTE_1,D;
		ORL P3,#0FH;        ( )
		MOV P1,#0FFH;          ( )
RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;         
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DECOD:    
ANL A,#0FH;      
CJNE A, #00h, D1;     0  
MOV A,#0C0h;          C0 -    .   
RET;
D1: CJNE A, #01h, D2;
MOV A,#0F9h;
RET;
D2: CJNE A, #02h, D3;
MOV A,#0A4h;
RET;
D3: CJNE A, #03h, D4;
MOV A,#0B0h;
RET;
D4: CJNE A, #04h, D5;
MOV A,#99h;
RET;
D5: CJNE A, #05h, D6;
MOV A,#92h;
RET;
D6: CJNE A, #06h, D7;
MOV A,#82h;
RET;
D7: CJNE A, #07h, D8;
MOV A,#0F8h;
RET;
D8: CJNE A, #08h, D9;
MOV A,#80h;
RET;
D9: CJNE A, #09h, DAt;
MOV A,#90h;
RET;
DAt: CJNE A, #0Ah, DBt;
MOV A,#88h;
RET;
DBt: CJNE A, #0Bh, DC;
MOV A,#83h;
RET;
DC: CJNE A, #0Ch, DD;
MOV A,#0C6h;
RET;
DD: CJNE A, #0Dh, DE;
MOV A,#0A1h;
RET;
DE: CJNE A, #0Eh, DF;
MOV A,#86h;
RET;
DF: CJNE A, #0Fh, EndDecod;
MOV A,#8Eh;
EndDecod: RET;
 ;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;      DS1307
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
GET_TIME_1307:
CLR LASTREAD;            ;       (  1307       )
CALL	 SEND_START	 ;   START
MOV	 A,#DS1307W;       ;   
CALL	 SEND_BYTE
MOV	 A,#00H; 						;    00H DS1307
CALL	 SEND_BYTE      ;    

CALL	 SEND_STOP	 	;   STOP
CALL	 SEND_START	 ;   START

MOV	 A,#DS1307R	 		;     DS1307
CALL	 SEND_BYTE

CALL	 READ_BYTE	 	;   
MOV	 SEC, A							;      

CALL	 READ_BYTE	 ;   
MOV	 MIN, A						 ;      

SETB LASTREAD;		;    (  1307      )
CALL	 READ_BYTE	 ;   
MOV	 CHA, A						;      

CALL	 SEND_STOP		 ;   STOP
RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;     
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
KLV:    ADD A,#00H;   ,      
				JB P1.7,NK;    
;
				CLR FLAG;
				MOV A, MIN;
				INC A;
				DA A;
				MOV MIN,A;
				CJNE A, #60H, K1;    60       
				MOV MIN,#00H;
K1:		MOV SEC,#00H;			 
				CALL SET_1307; 
				CALL KLV_DEL;
;		
NK:		JB P3.7,EK;    
;
				CLR FLAG;
				MOV A, CHA;
				INC A;
				DA A;
				MOV CHA,A;
				CJNE A, #24H, K2;    24       
				MOV CHA,#00H;
K2:		MOV SEC,#00H;			 
				CALL SET_1307; 
				CALL KLV_DEL;
;
EK: 		RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;    
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
KLV_DEL:
					MOV DELAY_BYTE_2,#9FH;
EN1:  		CALL INDIC;    !
      			DJNZ DELAY_BYTE_2, EN1;
RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   DS1307
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
SET_1307:
			CALL	 SEND_START; 			  START
			MOV	 A,#DS1307W ;			 	   DS1307 
			CALL	 SEND_BYTE
			MOV	 A,#00H		 ; 						    0   1307
			CALL	 SEND_BYTE;
			ANL SEC,#7FH; 					  (D7)   
			MOV	 A, SEC;								
			CALL	 SEND_BYTE	 
			MOV	 A,MIN;									
			CALL	 SEND_BYTE
			MOV	 A,CHA;									
			CALL	 SEND_BYTE

			CALL	 SEND_STOP	 ;   STOP
RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;																	                      I2C
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;
;     START
;
SEND_START: 
SETB	 _2W_BUSY		 ; ,     
CLR	 ACK							 ;   
CLR	 BUS_FAULT
JNB	 SCL,FAULT		 	;  
JNB	 SDA,FAULT		 	;   START
SETB	 SDA 
CALL	 SCL_HIGH		 ; SDA
CLR	 SDA
;
CALL	 DELAY			 ; SCL ^START
CLR	 SCL 
RET
FAULT:
SETB	 BUS_FAULT		 ;   
RET				 ;    
;
;     STOP
;
SEND_STOP: 
CLR	 SDA			 ; SDA
CALL	 SCL_HIGH 
SETB 	 SDA			 ; SCL ^STOP 
CLR	 _2W_BUSY
RET
;
;       DS1307
;
SEND_BYTE:
MOV	 BITCOUNT,#08H		 ;  ר  8 
SB_LOOP:
JNB	 ACC.7,NOTONE		 ;     7 ACC 1
SETB	 SDA						 ;  SDA    
JMP	 ONE
NOTONE:
CLR	 SDA			 				;  SDA  (0)
ONE:
CALL	 SCL_HIGH		 ;   SCL    
RL	 A			 							 ;   ACC  1 
CLR	 SCL							 ;   SCL    
DJNZ	 BITCOUNT,SB_LOOP	 ;   8 
SETB SDA							 ;   SDA  .    Ȩ
CALL	 SCL_HIGH		;   SCL    

CLR	 ACK			 				;    Ȩ
JNB	 SDA,SB_EX			;   .  .
SETB	 ACK			 			;     
SB_EX:
CALL	 DELAY			 		;  
CLR	 SCL			 				;   SCL    
CALL	 DELAY				 	;   
RET
;
;       DS1307
;
READ_BYTE:
MOV	 BITCOUNT,#08		 ;  ר  8  
CLR	 A; 
SETB	 SDA									 ;  SDA      
READ_BITS:
CALL	 SCL_HIGH		  		;  SCL    
MOV	 C,SDA									 ;       \
RLC	 A												 ;     ACC.0
CLR	 SCL										 ;  SCL    
DJNZ	 BITCOUNT,READ_BITS	 ;   8 
JB	 LASTREAD,ACKN		 	;       ? (      1307  )
CLR	 SDA			 							;    ,   
ACKN:
CALL	 SCL_HIGH		 			;  SCL     (   )
CLR	 SCL			 							;   
RET
; 
;     SCL    
;
SCL_HIGH:
SETB	 SCL			 ;  SCL  
JNB	 SCL,$			 ;    SCL   
RET
; 
;      
;
DELAY:
NOP				 ;  
RET
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;																	                      1-WIRE
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;    1-Wire ( DELAY_BYTE_1)
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RESET_LINE: ; RESET_LINE() : NILL
		 CLR I_WIRE;     
       MOV DELAY_BYTE_1,#0F0H;     480  - 240 (F0)  
R_1:   DJNZ DELAY_BYTE_1,R_1;
       SETB I_WIRE;    
       MOV DELAY_BYTE_1,#0F0H;     480  - 240 (F0)  
R_2:   DJNZ DELAY_BYTE_1,R_2;       
RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;    1  (, , SEND_BYTE - ) !!!!!!!!!!!!!!!
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
OUT_BYTE: ; OUT_BYTE(IO_BYTE) : NILL
GH:  
			MOV A,IO_BYTE; 		 	 
         MOV B, #08; 				 
;   ( 1-WIRE)
STARTT:	CLR I_WIRE;       		
			NOP;              		 !!!!    ,      
         NOP;
         NOP;
         JNB ACC.0,NOL; 			   "0"     
         SETB I_WIRE;               1    
;         
NOL:		RR A; 						   (   )
			MOV DELAY_BYTE_1,#1BH; 	  55  (     60)
PO2:		DJNZ DELAY_BYTE_1, PO2;     
;
         SETB I_WIRE;				 
;
        MOV DELAY_BYTE_1,#05H;     (11 ) 
FP:     DJNZ DELAY_BYTE_1,FP;
;
         DJNZ B, STARTT;              ?
RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;    1  (, , IO_BITE - )  !!!!!!!!!!!!!!!!!!!!!
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
IN_BYTE: ; IN_BYTE() => IO_BITE
			MOV A,#0FFH;					 ,    
         MOV B, #08;                 
			 
TAKT:		CLR I_WIRE;                
         NOP;                       
         SETB I_WIRE;               
         MOV DELAY_BYTE_1,#06;            
LK:		DJNZ DELAY_BYTE_1, LK;
;
			JB I_WIRE, SLEDU;				  
			CLR ACC.0;                          
SLEDU:	RR A;                      
			MOV DELAY_BYTE_1, #23;      Trelase = 45 
YTP:		DJNZ DELAY_BYTE_1, YTP;
         DJNZ B, TAKT;                    
         MOV IO_BYTE, A;                  
RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;       CRC. ( )  A.
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; DO_CRC(A) => CRC
DO_CRC:         PUSH    ACC        ;save bits to be shifted
                MOV     B,#8       ;set shift = 8 bits ;
CRC_LOOP:       XRL     A,CRC      ;calculate CRC
                RRC     A          ;move it to the carry
                MOV     A,CRC      ;get the last CRC value
                JNC     ZERO       ;skip if data = 0
                XRL     A,#18H     ;update the CRC value
                                   ;
ZERO:           RRC     A          ;position the new CRC
                MOV     CRC,A      ;store the new CRC
                POP     ACC        ;get the remaining bits
                RR      A          ;position the next bit
                PUSH    ACC        ;save the remaining bits
                DJNZ    B,CRC_LOOP ;repeat for eight bits
                POP     ACC        ;clean up the stack
RET;
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;    9  ( R0, IO_BYTE;  - IO_BYTE;   @20...@28)
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
READ_9_BYTE:        MOV CRC, #00; 			  
						  CLR C;                   .
						  MOV R0,#1FH; 			    
R_A:                  CALL IN_BYTE; 		    IO_BYTE
                      MOV A,IO_BYTE; 	      
                    INC R0;                     
                    MOV @R0,A;               (R0)  
                    CLR C;
                    CALL DO_CRC;  			  
                    MOV A,R0;               
                    XRL A,#27H;                 
                    JNZ R_A;                     
                    
                    CALL IN_BYTE;       	    
                    
 					  	  MOV A, IO_BYTE;  	          ( )                  
						  MOV CRC_DATCHIKA, A;     
;
						  CLR CRT_OK;             
						  XRL A, CRC;               
						  JNZ HRENOVO;              ,     
						  SETB CRT_OK;                -    !
; @20 - BYTE 0 -   
; @21 - BYTE 1 -   
; @22 - BYTE 2 - TH/  1
; @23 - BYTE 3 - TL/  2
; @24 - BYTE 4 - 
; @25 - BYTE 5 - 
; @26 - BYTE 6 - COUNT REMAIN
; @27 - BYTE 7 - COUNT PER C
; @28 - BYTE 8 - CRC
HRENOVO: RET; 
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; *************       ********************************
;     ( IO_BYTE, TEMPERATURA_L, TEMPERATURA_H)
;   -  
;    .    - 
;      MINUS
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
GET_T:     CLR MINUS;                   ,     
				  		CLR SOTNIA;
              		CLR C;
						MOV TEMP_BYTE_1, #POPITOK_CHTENIA;   
ZANOVO:				CALL RESET_LINE;             . 
                   MOV IO_BYTE,#0CCH;
                   CALL OUT_BYTE;               " " ( CCh). 
                   MOV IO_BYTE,#0BEH;
                   CALL OUT_BYTE;               "  " ( BEh). 
                  CALL READ_9_BYTE;       	   9  ( ). 
						JB CRT_OK, VSE_OK;  			        
                  DJNZ TEMP_BYTE_1, ZANOVO;      
;                  JMP VSE_OK;                    

						JMP IZMERIT; 					     ,   
;
VSE_OK:  MOV A,TEMPERATURA_L;      ()
                  ANL A,#0F0H;             D3..D0, -  
                  MOV TEMP_BYTE_1, A;    TEMP_BYTE
                  MOV A,TEMPERATURA_H;      ()
						ANL A,#0FH;             D7..D4, -   
                  ORL A, TEMP_BYTE_1;        ( )
                  SWAP A;                  			  
                  MOV TEMP_BYTE_1, A;        TEMP_BYTE
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;      -
;  -  SOTNIA, ,  - TEMP_C,      
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
DECOD_KOD:    CLR C; 							       
				  CLR AC;							        
				  JNB TEMP_BYTE_1.7,PLUS;       ,      
				  SETB MINUS;                     .  -   
				  CLR TEMP_BYTE_1.7;
              DEC TEMP_BYTE_1;            
              XRL TEMP_BYTE_1,#7FH;           -   -    
PLUS:         INC TEMP_BYTE_1;            +1         DJNZ
	           CLR A;
              DEC A;                         
M:            INC A;                       1   - 
              DA A;                        
              JNC N;                         +1 
              SETB SOTNIA;                 +1 
              CLR C;              		    
N:            DJNZ TEMP_BYTE_1,M;      	-1   ;    
              MOV TEMP_C, A;        		  ( -)  TEMP_C
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
IZMERIT:				CALL RESET_LINE;                . 
                  MOV IO_BYTE,#0CCH;
                  CALL OUT_BYTE;        			  " " ( CCh). 
                  MOV IO_BYTE,#44H;
                  CALL OUT_BYTE;         " " ( 44h).
RET;

END;
